/* Factor - factorize numbers
   Copyright (C) 2006 Håvard Moen <post@haavard.name>

   Factor is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as published
   by the Free Software Foundation.

   Factor is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Factor; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

import javax.microedition.lcdui.*;

public class FactorThread extends Thread {

  private long number;
  private StringItem resultDisplay;

  public FactorThread(long number, StringItem resultDisplay) {
    this.number = number;
    this.resultDisplay = resultDisplay;
  }

  public void run() {
    long n = this.number;
    if (n < 4) {
      String s = Long.toString(n);
      this.resultDisplay.setText(s);
      return;
    }

    long sqrt = IntMath.intSqr(this.number);

    long i = 2;
    long q = n / i;
    while (q * i == n) {
      String s = this.resultDisplay.getText();
      s = s + " " + Long.toString(i);
      this.resultDisplay.setText(s);
      n = q;
      q = n / i;
    }
    i = 3;
    while(n > 1 && i <= sqrt) {
      q = n / i;
      while (q * i == n) {
        String s = this.resultDisplay.getText();
        s = s + " " + Long.toString(i);
        this.resultDisplay.setText(s);
        n = q;
        q = n / i;
      }
      i += 2;
    }
    if (n > 1) {
      String s = this.resultDisplay.getText();
      s = s + " " + Long.toString(n);
      this.resultDisplay.setText(s);
    }
  }
}
