/* Factor - factorize numbers
   Copyright (C) 2006 Håvard Moen <post@haavard.name>

   Factor is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as published
   by the Free Software Foundation.

   Factor is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Factor; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

import javax.microedition.lcdui.*;

public class FindThread extends Thread {

  private long min;
  private long max;
  private StringItem resultDisplay;

  public FindThread(long min, long max, StringItem resultDisplay) {
    this.min = min;
    this.max = max;
    this.resultDisplay = resultDisplay;
  }

  public void run() {
    for (long n = min; n <= max; n++) {
      if (isPrime(n)) {
        String s = this.resultDisplay.getText();
        s = s + " " + Long.toString(n);
        this.resultDisplay.setText(s);
      }
    }
  }

  private boolean isPrime(long n) {
    if (n < 4 && n > 1) {
      return true;
    }

    if (n % 2 == 0) {
      return false;
    }

    long sqrt = IntMath.intSqr(n);

    long i = 3;
    long q;
    while(i <= sqrt) {
      q = n / i;
      if (q * i == n) {
        return false;
      }
      i += 2;
    }
    return true;
  }
}
