/* Factor - factorize numbers
   Copyright (C) 2006 Håvard Moen <post@haavard.name>

   Factor is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as published
   by the Free Software Foundation.

   Factor is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Factor; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

public class IntMath {
  /* Not all phones have support floating point, therefore we cannot use
   * Math.sqrt. Besides we don't need the exact number and this function 
   * is pretty fast 
   */
  public static long intSqr(long i) {
    long prev = 0;
    long k = i;
    int max = 1000;

    while (prev != k && max > 0) {
      prev = k;
      k = (k + i / k) / 2;
      max--;
    }

    return k;
  }
}
